<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Task 530</title>
    <!--Bootstrap-->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/css/bootstrap.min.css"
        integrity="sha384-rbsA2VBKQhggwzxH7pPCaAqO46MgnOM80zW1RWuH61DGLwZJEdK2Kadq2F9CUG65" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.min.js"
        integrity="sha384-cuYeSxntonz0PPNlHhBs68uyIAVpIIOZZ5JqeqvYYIcEL727kskC66kF92t6Xl2V"
        crossorigin="anonymous"></script>
    <!--Jquery-->
    <script src="https://code.jquery.com/jquery-3.7.0.js"
        integrity="sha256-JlqSTELeR4TLqP0OG9dxM7yDPqX1ox/HfgiSLBj8+kM=" crossorigin="anonymous"></script>
    <!--DataTable-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.13.6/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.13.6/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.6/js/dataTables.bootstrap4.min.js"></script>
    <!--Font Awesome-->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.2/css/all.min.css"
        integrity="sha512-z3gLpd7yknf1YoNbCzqRKc4qyor8gaKU1qmn+CShxbuBusANI9QpRohGBreCFkKxLhei6S9CQXFEbbKuqLg0DA=="
        crossorigin="anonymous" referrerpolicy="no-referrer" />
    <link rel="stylesheet" href="530.css">
</head>

<body>
    <div class="container">
        <h3 class="text-center">DANH SÁCH SẢN PHẨM </h3>
        <div class="bg-secondary filter-area">
            <form class="row">
                <div class="col-5 row">
                    <label for="country-filter-choosing-selected" class="col-3">Quốc gia</label>
                    <select id="country-filter-choosing-selected" class="col-9">
                        <option value="0">None</option>
                    </select>
                </div>
                <div class="col-5 row">
                    <label for="category-filter-choosing-selected" class="col-3">Nhóm sản phẩm</label>
                    <select id="category-filter-choosing-selected" class="col-9">
                        <option value="0">None</option>
                    </select>
                </div>
                <button class="btn btn-success col-2" id="filter-btn">Lọc sản phẩm</button>
            </form>
        </div>
        <div class="my-4">
            <button class="btn btn-success"><i class="fa-solid fa-plus"></i>&nbsp; Thêm sản phẩm</button>
        </div>
        <table id="product-table" class="table table-striped table-hover table-bordered table-primary">
            <thead>
                <tr>
                    <th>STT</th>
                    <th>Mã sản phẩm</th>
                    <th>Tên sản phẩm</th>
                    <th>Nhóm sản phẩm</th>
                    <th>Quốc gia</th>
                    <th>Ảnh đại diện</th>
                    <th>Giá bán</th>
                    <th>Giá giảm</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>

    <div id="edit-product-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="h5-modal-title">Chỉnh sửa Product</h5>
                    <button class="close btn-close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                    <form>
                        <div class="row form-group my-3">
                            <div class="col-sm-4">
                                <label for="edit-id-product-product">Mã sản phẩm</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="edit-id-product-product" name="user"
                                    class="form-control inp-form">
                            </div>
                        </div>
                        <div class="row form-group my-3">
                            <div class="col-sm-4">
                                <label for="edit-product-name">Tên sản phẩm</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="edit-product-name" name="user" class="form-control inp-form">
                            </div>
                        </div>
                        <div class="row form-group my-3">
                            <div class="col-sm-4">
                                <label for="edit-category-type-product">Nhóm sản phẩm</label>
                            </div>
                            <div class="col-sm-8">
                                <select id="edit-category-type-product" name="user" class="form-control inp-form">
                                    <option value="0">None</option>

                                </select>

                            </div>
                        </div>
                        <div class="row form-group my-3">
                            <div class="col-sm-4">
                                <label for="edit-country-product">Quốc Gia</label>
                            </div>
                            <div class="col-sm-8">
                                <select id="edit-country-product" name="user" class="form-control inp-form">
                                    <option value="0">None</option>

                                </select>
                            </div>
                        </div>
                        <div class="row form-group my-3">
                            <div class="col-sm-4">
                                <label for="input-customer-type-user">Ảnh Đại Diện</label>
                            </div>
                            <div class="col-sm-8" id="avatar-edit-product">
                                <img class="img-thumbnail" src="">
                            </div>
                        </div>
                        <div class="row form-group my-3">
                            <div class="col-sm-4">
                                <label for="edit-original-price">Giá gốc</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="edit-original-price" name="user" class="form-control inp-form">
                            </div>
                        </div>
                        <div class="row form-group my-3">
                            <div class="col-sm-4">
                                <label for="edit-discount-price">Giá giảm</label>
                            </div>
                            <div class="col-sm-8">
                                <input type="text" id="edit-discount-price" name="user" class="form-control inp-form">
                            </div>
                        </div>

                    </form>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-success" id="btn-edit-user" data-dismiss="modal">Confirm</button>
                    <button class="btn btn-success" id="btn-cancel">Hủy Bỏ</button>
                </div>
            </div>
        </div>
    </div>


</body>

<script>
    'use strict'
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "https://63b401c1ea89e3e3db539072.mockapi.io/api/v1/";
    const vAPI_URL = gBASE_URL + "/products/";
    var gProduct = [];
    var gCategoryList = [];
    var gCountryList = [];
    const gDATA = ['id', 'productCode', 'productName', 'categoryId', 'countryId', 'imagUrl', 'price', 'discountPrice', 'action'];
    const gID_COL = 0;
    const gPRODUCT_CODE_COL = 1;
    const gPRODUCT_NAME_COL = 2;
    const gCATEGORY_ID_COL = 3;
    const gCOUNTRY_ID_COL = 4;
    const gIMAGE_URL_COL = 5;
    const gPRICE_COL = 6;
    const gDISCOUNT_PRICE_COL = 7;
    const gACTION_COL = 8;
    var gTable = $("#product-table").DataTable({
        columns: [
            { data: gDATA[gID_COL] },
            { data: gDATA[gPRODUCT_CODE_COL] },
            { data: gDATA[gPRODUCT_NAME_COL] },
            {
                data: gDATA[gCATEGORY_ID_COL],
                render: function (data) {
                    gCategoryList.find((category) => {
                        category.id == data;
                        return `<span>${category.categoryName}</span>`
                    })
                }
            },
            {
                data: gDATA[gCOUNTRY_ID_COL],
                render: function (data, type, row) {
                    console.log(gCountryList);
                    for (var bI = 0; bI < gCountryList.length; bI++) {
                        if (type == "display") {
                            var bIdCountryFromProduct = row.countryId;
                            var bNameCountryFromCountriesAPI = gCountryList[bI].countryName;
                            var bIdCountryFromCountriesAPI = gCountryList[bI].id;
                            if (data == bIdCountryFromCountriesAPI) {
                                return `<p>${bNameCountryFromCountriesAPI}</p>`
                            }
                        }

                    }
                }
            },
            { data: gDATA[gIMAGE_URL_COL] },
            { data: gDATA[gPRICE_COL] },
            { data: gDATA[gDISCOUNT_PRICE_COL] },
            { data: gDATA[gACTION_COL] },
        ],
        columnDefs: [
            {
                targets: gACTION_COL,
                className: "text-center",
                defaultContent: `
                    <a class="edit-btn"><i class="fa-solid fa-pen-to-square text-primary"></i></a>
                    <a class="delete-btn"><i class="fa-solid fa-trash-can text-danger"></i></a>`
            },
            {
                targets: gIMAGE_URL_COL,
                render: (data) => {
                    return `<img alt="" src="${data}">`
                }
            }

        ]
    })


    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
    });
    $("#product-table").on("click", '.edit-btn', function () {
        onEditBtnClick(this);
    })

    function onPageLoading() {
        callApiProducts();
        callApiCategoryId();
        callApiCountry();
    }
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onEditBtnClick(paramElement) {
        $("#edit-product-modal").modal("show");
        var vRow = $(paramElement).parents("tr");
        var vData = gTable.row(vRow).data();
        console.log(vData)
        callApiFromId(vData);
    }

    function callApiFromId(paramId) {
        $.ajax({
            url: vAPI_URL + paramId.id,
            type: 'get',
            success: function (res) {
                loadInformationIntoModal(res);
            },
            error: function (error) {
                console.log(error.responseText)
            }
        })
    }

    function loadInformationIntoModal(paramProduct) {
        $("#edit-id-product-product").val(paramProduct.productCode);
        $("#edit-product-name").val(paramProduct.productName);
        $("#edit-category-type-product").val(paramProduct.categoryId);
        $("#edit-country-product").val(paramProduct.countryId);
        $("#avatar-edit-product").html(`<img src="${paramProduct.imagUrl}">`);
        $("#edit-original-price").val(paramProduct.price);
        $("#edit-discount-price").val(paramProduct.discountPrice);
    }

    function callApiCountry() {
        $.ajax({
            url: gBASE_URL + "/countries/",
            type: 'get',
            async: false,
            success: function (res) {
                console.log(res);
                gCountryList = res;
                loadInformationIntoCountrySelected(gCountryList);
                loadInformationIntoCountrySelectedModal(gCountryList);
            },
            error: function (error) {
                console.log(error);
            }
        })
    }

    function callApiProducts() {
        $.ajax({
            url: vAPI_URL,
            type: 'GET',
            async: false,
            success: function (res) {
                gProduct = res;
                loadApiIntoTable(res);
            },
            error: function (error) {
                console.log(error.responseText);
            }
        })
    }

    function callApiCategoryId() {
        $.ajax({
            url: gBASE_URL + "/categories/",
            type: 'GET',
            async: false,
            success: function (res) {
                console.log(res);
                loadInformationIntoCategorySelected(res)
                loadInformationIntoCategorySelectedModal(res);
            },
            error: function (error) {
                console.log(error.responseText);
            }
        })
    }

    function loadApiIntoTable(paramProductList) {
        gTable.clear();
        gTable.rows.add(paramProductList);
        gTable.draw();
    }

    function loadInformationIntoCountrySelectedModal(paramCountryList) {
        for (let bI = 0; bI < paramCountryList.length; bI++) {
            $("<option>", {
                html: paramCountryList[bI].countryName,
                value: paramCountryList[bI].id
            }).appendTo($("#edit-country-product"))
        }
    }


    function loadInformationIntoCountrySelected(paramCountryList) {
        gCountryList = paramCountryList;
        for (let bI = 0; bI < paramCountryList.length; bI++) {
            $("<option>", {
                html: paramCountryList[bI].countryName,
                value: paramCountryList[bI].id
            }).appendTo($("#country-filter-choosing-selected"))
        }
    }

    function loadInformationIntoCategorySelectedModal(paramCategoryList) {
        gCategoryList = paramCategoryList;
        for (let bI = 0; bI < paramCategoryList.length; bI++) {
            $("<option>", {
                html: paramCategoryList[bI].categoryName,
                value: paramCategoryList[bI].id
            }).appendTo($("#edit-category-type-product"))
        }

    }

    function loadInformationIntoCategorySelected(paramCategoryList) {
        gCategoryList = paramCategoryList;
        for (let bI = 0; bI < paramCategoryList.length; bI++) {
            $("<option>", {
                html: paramCategoryList[bI].categoryName,
                value: paramCategoryList[bI].id
            }).appendTo($("#category-filter-choosing-selected"))
        }

    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/

</script>

</html>